diff -urN sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2019-08-20 10:11:06.805000100 +1000
+++ source/scripts/jmgBearHunter.cpp	2020-09-26 08:59:57.398127800 +1000
@@ -89,6 +89,7 @@
 		Commands->Start_Timer(obj,this,24.0f,3);
 		Commands->Start_Timer(obj,this,34.0f,4);
 		PlayerData.players[playerId]->killsWithoutGettingHurt = 0;
+		PlayerData.players[playerId]->hasAnnounced10 = false;
 	}
 	if (PlayerData.players[playerId]->firstJoin)
 		Commands->Start_Timer(obj,this,0.1f,5);
@@ -106,17 +107,13 @@
 	if (JMG_Bear_Hunter_Game_Control::bearTransition && JMG_Bear_Hunter_Game_Control::bearTransition < 100)
 		Commands->Start_Timer(obj,this,0.1f,7);
 	Commands->Start_Timer(obj,this,0.1f,1);
-	if ((JMG_Bear_Hunter_Game_Control::gameState != JMG_Bear_Hunter_Game_Control::BossArrive || JMG_Bear_Hunter_Game_Control::remainingLives[playerId] >= 0) && Get_Player_Name(obj) && _wcsicmp(WideStringClass(Get_Player_Name(obj)), The_Game()->Get_Mvp_Name()) == 0 && !_stricmp("CNC_Spawned_Soldier",Commands->Get_Preset_Name(obj)))
-		switch (The_Game()->Get_Mvp_Count())
-		{
-		case 0:break;
-		case 1:Commands->Set_Model(obj,"c_h_deer");break;
-		case 2:Commands->Set_Model(obj,"c_s_deer");break;
-		default:Commands->Set_Model(obj,"c_gi_deer");break;
-		}
 	Attach_Script_Once(obj,"JFW_Send_Self_Custom_On_Key","VehBind,454269,0");
 	Commands->Attach_Script(obj,"JMG_Rp2_Dedicated_Server_Sound_Emulator","");
 	Commands->Start_Timer(obj,this,2.5f,8);
+	if (The_Game()->Get_Game_Duration_S() < 0.25f)
+		Commands->Start_Timer(obj,this,0.25f,9);
+	else
+		Timer_Expired(obj,9);
 }
 void JMG_Bear_Hunter_Player_Soldier::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
@@ -168,34 +165,29 @@
 		Commands->Start_Timer(obj,this,0.1f,1);
 	}
 	if (number == 2)
+	{
 		switch (JMG_Bear_Hunter_Game_Control::gameState)
 		{
 		case JMG_Bear_Hunter_Game_Control::LeaveBase:case JMG_Bear_Hunter_Game_Control::HuntBears:
-			JmgUtility::DisplayChatMessage(obj,127,127,255,"Bear Rug Co: Hello, you must be here for the money, as I'm sure you've heard, Bear Rug Co. is in desperate need for bear rugs, and we are willing to pay 30 dollars a pelt.");
-			Create_2D_Wave_Sound_Dialog_Player(obj,"BH1.mp3");return;
+			BearHunterVoiceSystem::PlayVoice(obj,"BH1.mp3","Bear Rug Co: Hello, you must be here for the money, as I'm sure you've heard, Bear Rug Co. is in desperate need for bear rugs, and we are willing to pay 30 dollars a pelt.");return;
 		case JMG_Bear_Hunter_Game_Control::MutationStart:
-			JmgUtility::DisplayChatMessage(obj,127,127,255,"Bear Rug Co: Hello, I'm sure you came down to make some money killing bears, got some good news for you: a tiberium meteorite hit, and mutated the wildlife, mutant bear pelts are far more valuable, head north and join in the fun!");
-			Create_2D_Wave_Sound_Dialog_Player(obj,"BH2.mp3");return;
+			BearHunterVoiceSystem::PlayVoice(obj,"BH2.mp3","Hello, I'm sure you came down to make some money killing bears, got some good news for you: a tiberium meteorite hit, and mutated the wildlife, mutant bear pelts are far more valuable, head north and join in the fun!");return;
 		case JMG_Bear_Hunter_Game_Control::FallBack:case JMG_Bear_Hunter_Game_Control::DefendPrez:
-			JmgUtility::DisplayChatMessage(obj,127,127,255,"Bear Rug Co: Welcome, its a bad time for you to have joined us, a tiberium meteorite hit, and now we're under attack by mutant wildlife, grab a gun and help us defend the President of Corporate America!");
-			Create_2D_Wave_Sound_Dialog_Player(obj,"BH3.mp3");return;
+			BearHunterVoiceSystem::PlayVoice(obj,"BH3.mp3","Bear Rug Co: Welcome, its a bad time for you to have joined us, a tiberium meteorite hit, and now we're under attack by mutant wildlife, grab a gun and help us defend the President of Corporate America!");return;
 		case JMG_Bear_Hunter_Game_Control::SecureBase:
-			JmgUtility::DisplayChatMessage(obj,127,127,255,"Bear Rug Co: Greetings, victory is at hand, all we need to do is kill the remaining mutants inside the base!");
-			Create_2D_Wave_Sound_Dialog_Player(obj,"BH4.mp3");return;
+			BearHunterVoiceSystem::PlayVoice(obj,"BH4.mp3","Bear Rug Co: Greetings, victory is at hand, all we need to do is kill the remaining mutants inside the base!");return;
 		case JMG_Bear_Hunter_Game_Control::BossArrive:
-			JmgUtility::DisplayChatMessage(obj,127,127,255,"Bear Rug Co: Greetings, Kill the boss and this will be all over!");
-			Create_2D_Wave_Sound_Dialog_Player(obj,"BH5.mp3");return;
+			BearHunterVoiceSystem::PlayVoice(obj,"BH5.mp3","Bear Rug Co: Greetings, Kill the boss and this will be all over!");return;
 		}
+	}
 	if (number == 3)
 	{
-		JmgUtility::DisplayChatMessage(obj,127,127,255,"Bear Rug Co: Feel free to buy weapons at your nearest PCT, and once your ready, head north into the swamp and start making some money!");
-		Create_2D_Wave_Sound_Dialog_Player(obj,"BH6.mp3");
+		BearHunterVoiceSystem::PlayVoice(obj,"BH6.mp3","Bear Rug Co: Feel free to buy weapons at your nearest PCT, and once your ready, head north into the swamp and start making some money!");
 	}
 	if (number == 4)
 	{
 		PlayerData.players[playerId]->hasGotIntro = true;
-		JmgUtility::DisplayChatMessage(obj,127,127,255,"Bear Rug Co: Oh, and as a tempory promotion, we are giving out an extra $50.00 every time someone kills 10 in a row without getting hurt! And we'll give out $1,000.00 to anyone that can kill 250!");
-		Create_2D_Wave_Sound_Dialog_Player(obj,"BH7.mp3");
+		BearHunterVoiceSystem::PlayVoice(obj,"BH7.mp3","Bear Rug Co: Oh, and as a tempory promotion, we are giving out an extra $50.00 every time someone kills 10 in a row without getting hurt! And we'll give out $1,000.00 to anyone that can kill 250!");
 	}
 	if (number == 5)
 	{
@@ -226,10 +218,31 @@
 		MoveablePhysClass *mphys = obj->As_PhysicalGameObj() ? obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
 		if (mphys && !mphys->Can_Teleport(Matrix3D(pos)))
 		{
-			mphys->Find_Teleport_Location(pos,2.5f,&pos);
+			mphys->Find_Teleport_Location(pos,1.25f,&pos);
 			Commands->Set_Position(obj,pos);
 		}
 	}
+	if (number == 9)
+	{
+		BearHunterScoreSystem::BHScoreNode *scoreNode = bearHunterScoreSystem.Get_Current_Player_Score_Node(playerId);
+		if ((JMG_Bear_Hunter_Game_Control::gameState != JMG_Bear_Hunter_Game_Control::BossArrive || JMG_Bear_Hunter_Game_Control::remainingLives[playerId] >= 0) && Get_Player_Name(obj) && !_stricmp("CNC_Spawned_Soldier",Commands->Get_Preset_Name(obj)))
+			switch (scoreNode->Rank)
+			{
+			case 0:break;
+			case 1:Commands->Set_Model(obj,"c_masterbleat");break;
+			case 2:Commands->Set_Model(obj,"c_knight_deer");break;
+			case 3:Commands->Set_Model(obj,"c_fremen_deer");break;
+			case 4:Commands->Set_Model(obj,"c_gz_deer");break;
+			case 5:Commands->Set_Model(obj,"c_apb_deer");break;
+			case 6:Commands->Set_Model(obj,"c_gi_deer");break;
+			case 7:Commands->Set_Model(obj,"c_ia_deer");break;
+			case 8:Commands->Set_Model(obj,"c_cmd_deer");break;
+			case 9:Commands->Set_Model(obj,"c_ren_deer");break;
+			case 10:Commands->Set_Model(obj,"c_hobo_deer");break;
+			case 11:Commands->Set_Model(obj,"c_tsr_deer");break;
+			}
+		GrantSpecialUnlocks(obj);
+	}
 }
 void JMG_Bear_Hunter_Player_Soldier::Damaged(GameObject *obj,GameObject *damager,float damage)
 {
@@ -366,6 +379,28 @@
 		break;
 	}
 }
+void JMG_Bear_Hunter_Player_Soldier::GrantSpecialUnlocks(GameObject *obj)
+{
+	BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(playerId);
+	if (node->KilledMutantBears+node->KilledMutantDeer+node->KilledMutantCats+node->KilledMutantCatsB+node->KilledMutantCatsR+node->KilledMutantRabbits+node->MutantDogKilled+node->BlueDeerKilled+node->MooseKilled+node->MutantSquirrelsKilled >= 4000)
+		Grant_Weapon(obj,"Weapon_Knife",true,1,true);
+	if (node->KilledBears+node->KilledBlackBears+node->WolfKilled+node->TinyDeerKilled+node->WildDeerKilled+node->WildSquirrelsKilled+node->KilledMice >= 1000)
+		Grant_Weapon(obj,"Weapon_Fire_Axe",true,1,true);
+	if (node->PlayTime > 60000)
+		Grant_Weapon(obj,"Weapon_Ruger_10/22",true,500,true);
+	if (NewObjectiveSystemControl.Get_Objective_Status(27) == NewObjectiveSystem::Accomplished)
+	{
+		Grant_Weapon(obj,"Weapon_Milk_Whole",true,500,true);
+		Grant_Weapon(obj,"Weapon_Milk_2Percent",true,500,true);
+	}
+	if (!PlayerData.players[playerId]->portablePumpjackId && bearHunterScoreSystem.Get_Current_Player_Score_Node(playerId)->BonusObjectivesCompleted >= 100)
+	{
+		Grant_Weapon(obj,"Weapon_Portable_Pumpjack_Beacon",true,1,true);
+		Commands->Attach_Script(obj,"JMG_Bear_Hunter_PumpJack_Detect_Oil","");
+	}
+	if (bearHunterScoreSystem.Get_Current_Player_Score_Node(playerId)->KilledMice >= 25)
+		Grant_Weapon(obj,"Weapon_Pepper_A_Salt",true,80,true);
+}
 void JMG_Rp2_Dedicated_Server_Sound_Emulator::Created(GameObject *obj)
 {
 	weaponSoundRange = 40000.0f;
@@ -425,13 +460,13 @@
 			LastWeaponID = WeaponID;
 			switch (WeaponID)
 			{
-				case 409610052:case 409610005:case 409610127:case 1000001422: weaponSoundRange = 0.0f;break;
-				case 1393:case 3078:case 409610116:case 409610117:case 409610114:case 409610115:case 1000001128: weaponSoundRange = 2500.0f;break;
-				case 1000001082:case 409610007:case 409610006:case 1000001394:case 1000001423: weaponSoundRange = 10000.0f;break;
-				case 1000001073:case 2264:case 1000001399: weaponSoundRange = 22500.0f;break;
-				case 409610124:case 409610125: weaponSoundRange = 160000.0f;break;
-				case 409610123: weaponSoundRange = 250000.0f;break;
-				default: weaponSoundRange = 40000.0f;break;
+			case 409610052:case 409610005:case 409610127:case 1000001422:case 1000005027:case 1000010023:case 1000001665:case 1000010026:case 1000005017:case 1000001453: weaponSoundRange = 0.0f;break;
+			case 1393:case 3078:case 409610116:case 409610117:case 409610114:case 409610115:case 1000001128:case 1000005000: weaponSoundRange = 2500.0f;break;
+			case 1000001082:case 409610007:case 409610006:case 1000001394:case 1000001423: weaponSoundRange = 10000.0f;break;
+			case 1000001073:case 2264:case 1000001399: weaponSoundRange = 22500.0f;break;
+			case 409610124:case 409610125:case 1000010027: weaponSoundRange = 160000.0f;break;
+			case 409610123: weaponSoundRange = 250000.0f;break;
+			default: weaponSoundRange = 40000.0f;break;
 			}
 		}
 		LastBullets = CurrentBullets;
@@ -461,6 +496,7 @@
 	bearHunterScoreSystem = BearHunterScoreSystem();
 	AIPurchaseSystemControl = AIPurchaseSystem();
 }
+int BearHunterVoiceSystem::voiceId[128] = {0};
 void JMG_Bear_Hunter_Game_Control::Created(GameObject *obj)
 {
 	bonusObjectiveCount = 0;
@@ -480,17 +516,20 @@
 	deathWarheadId = ArmorWarheadManager::Get_Warhead_Type("Death");
 	JMG_Bear_Hunter_Player_Assist_AI::maxWait = -1;
 	JMG_Bear_Hunter_AI_Avoid_Enemies::wildAnimalCount = 0;
+	JMG_Bear_Hunter_AI_Avoid_Enemies::mouseAnimalCount = 0;
 	for (int x = 0;x < 128;x++)
 	{
 		aiIgnorePlayers[x] = 0;
 		remainingLives[x] = 0;
 		playerAlive[x] = true;
 		wanderingAiIgnorePlayers[x] = 0;
+		BearHunterVoiceSystem::voiceId[x] = 0;
 	}
 	bossRabitDead = 0;
 	bearTransition = 0;
 	objective = 12693;
 	NewObjectiveSystemControl.Add_Objective(1,NewObjectiveSystem::Primary,NewObjectiveSystem::Pending,12693,"",12693,Vector3(15.593f,-93.453f,-0.166f));
+	NewObjectiveSystemControl.Add_Objective(26,NewObjectiveSystem::Bonus,NewObjectiveSystem::Hidden,12842,"",12842);
 	spawnGroup = 0;
 	atCabin = false;
 	winWait = 0;
@@ -552,7 +591,6 @@
 	}
 	weaponsUnlocked[6] = false;
 	blackBearId = 0;
-	int pumpJackIds[7] = {601041,601038,601044,601040,601045,601039,601043};
 	for (int x = 0;x < 7;x++)
 	{
 		GameObject *pumpJack = Commands->Find_Object(pumpJackIds[x]);
@@ -583,6 +621,7 @@
 	Commands->Attach_Script(obj,"JMG_Utility_Dynamic_Clock_Control","");
 	Commands->Attach_Script(obj,"JMG_Bear_Hunter_Armored_Car_Controller","");
 	Commands->Attach_Script(obj,"JMG_Utility_Basic_Spawner_In_Radius","Skittish_Animal_Wander_Point,0.1,0.0,500,0.0,450.0,0.0,500.0,0.0 0.0 -1000.0,1.0,1.0,1,5,0.25,-1,-1,-1,1,1,0.0 0.0 1.0,0.0,1,5.0,1,0,0,0.0 0.0 0.0,-1,0.0");
+	Commands->Attach_Script(obj,"JMG_Utility_Basic_Spawner_In_Radius","AI_Mouse_Wanderpoint,0.1,0.0,250,0.0,135.0,0.0,250.0,0.0 -703.0 -1000.0,1.0,1.0,1,5,0.25,-1,-1,-1,1,1,0.0 0.0 1.0,0.0,1,5.0,1,0,0,0.0 0.0 0.0,-1,0.0");
 }
 void JMG_Bear_Hunter_Game_Control::Timer_Expired(GameObject *obj,int number)
 {
@@ -716,9 +755,8 @@
 					Commands->Set_Objective_HUD_Info_Position(3,2,"POGCabin.tga",7387,Vector3(15.593f,-93.453f,-0.166f));
 					if (NewObjectiveSystemControl.Get_Objective_Status(13) == NewObjectiveSystem::NotDefined)
 					{
-						JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: There is an alert system placed at the cabin, activating it would defintly attract attention of the bears.");
+						BearHunterVoiceSystem::PlayVoice("BH8.mp3","Bear Rug Co: There is an alert system placed at the cabin, activating it would defintly attract attention of the bears.");
 						NewObjectiveSystemControl.Add_Objective(13,NewObjectiveSystem::Secondary,NewObjectiveSystem::Pending,12739,"",12739);
-						JmgUtility::Create_2D_Wave_Sound_Dialog("BH8.mp3");
 					}
 				} 
 				if (!atCabin)
@@ -792,8 +830,7 @@
 						GameObject *player = Get_GameObj(x);
 						if (!player || Get_Player_Type(player) == -4 || JmgUtility::SimpleDistance(Commands->Get_Position(switchObj),Commands->Get_Position(player)) >= 22500)
 							continue;
-						JmgUtility::DisplayChatMessage(player,127,127,255,"Bear Rug Co: Great work holding those bears off, here is a small bonus!");
-						Create_2D_Wave_Sound_Dialog_Player(player,"BH9.mp3");
+						BearHunterVoiceSystem::PlayVoice(player,"BH9.mp3","Bear Rug Co: Great work holding those bears off, here is a small bonus!");
 						Commands->Give_Money(player,250.0f,0);
 						BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(x);
 						if (node)
@@ -822,8 +859,7 @@
 				gameTime = 1800;
 				JMG_Bear_Hunter_Player_Assist_AI::maxWait = 0;
 				NewObjectiveSystemControl.Set_Objective_Status(1,NewObjectiveSystem::Accomplished);
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We need more rugs, get out there and kill us some bears!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH10.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH10.mp3","Bear Rug Co: We need more rugs, get out there and kill us some bears!");
 				NewObjectiveSystemControl.Add_Objective(2,NewObjectiveSystem::Primary,NewObjectiveSystem::Pending,12694,"",12694);
 				sprintf(currentSong,"SpecForce_Sneak_02.mp3");
 				Commands->Fade_Background_Music("SpecForce_Sneak_02.mp3",10000,10000);
@@ -856,6 +892,7 @@
 					Attach_Script_Once(mlion,"JMG_Security_Camera_Behavior_Ignore","");
 					wildMountainLionIds[x] = Commands->Get_ID(mlion);
 				}
+				CreateCow();
 				return;
 			}
 		}
@@ -872,47 +909,40 @@
 				attackSubstationChance = 0.0f;
 			if (gameTime == 1780)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: There is a little cabin up north with some supplies, if you head up there you'll have easy hunting.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH11.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH11.mp3","Bear Rug Co: There is a little cabin up north with some supplies, if you head up there you'll have easy hunting.");
 				NewObjectiveSystemControl.Add_Objective(11,NewObjectiveSystem::Secondary,NewObjectiveSystem::Pending,12729,"",12729,Vector3(15.593f,-93.453f,-0.166f));
 			}
 			if (gameTime == 1770)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: 3 Pump Jacks have fallen into disrepair in the East, repair them for additional profit.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH12.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH12.mp3","Bear Rug Co: 3 Pump Jacks have fallen into disrepair in the East, repair them for additional profit.");
 				IncreaseBonusObjectiveCount(17);
 				NewObjectiveSystemControl.Add_Objective(17,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12748,"",12748,bonusObjectiveCount);
 			}
 			if (gameTime == 1760)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: 7 of our oil rigs to the north have gone off-line, if you head up there and activate them we'll give you a cut of the profits.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH13.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH13.mp3","Bear Rug Co: 7 of our oil rigs to the north have gone off-line, if you head up there and activate them we'll give you a cut of the profits.");
 				IncreaseBonusObjectiveCount(16);
 				NewObjectiveSystemControl.Add_Objective(16,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12758,"",12758,bonusObjectiveCount);
 			}
 			if (gameTime == 1730)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Oh also, we'll pay everyone big bucks if you can deliver the turret supplies from the warehouse in the North East.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH14.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH14.mp3","Bear Rug Co: Oh also, we'll pay everyone big bucks if you can deliver the turret supplies from the warehouse in the North East.");
 				NewObjectiveSystemControl.Add_Objective(9,NewObjectiveSystem::Tertiary,NewObjectiveSystem::Pending,12727,"",12727,Vector3(434.101f,539.071f,1.142f));
 			}
 			if (gameTime == 1700)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: One last thing, we had a helicopter go down in the swamp to the North West there are 5 surviving engineers that could use an escort back to base; we will of course pay for their safe return.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH15.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH15.mp3","Bear Rug Co: One last thing, we had a helicopter go down in the swamp to the North West there are 5 surviving engineers that could use an escort back to base; we will of course pay for their safe return.");
 				IncreaseBonusObjectiveCount(15);
 				NewObjectiveSystemControl.Add_Objective(15,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12741,"",12741,bonusObjectiveCount);
 			}
 			if (gameTime == 1500)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Half way there, you guys better get those bears while you can, because they won't be worth much when we hit our quota!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH16.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH16.mp3","Bear Rug Co: Half way there, you guys better get those bears while you can, because they won't be worth much when we hit our quota!");
 			}
 			if (gameTime == 1196)
 			{
 				gameState = MutationStart;
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Wow! Was that a Tiberium meteorite that just hit?");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH17.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH17.mp3","Bear Rug Co: Wow! Was that a Tiberium meteorite that just hit?");
 				BearHunterWolfHivemindSystem::BearHunterWolfHivemindNode *node = bearHunterWolfHivemindControl.find(2);
 				if (node)
 					node->maxPackSize = 5;
@@ -940,7 +970,6 @@
 			if (gameTime == 1190)
 			{
 				int livingPumpjacks = 0,inactivePumpjackCount = 0;
-				int pumpJackIds[7] = {601041,601038,601044,601040,601045,601039,601043};
 				for (int x = 0;x < 7;x++)
 				{
 					GameObject *pumpJack = Commands->Find_Object(pumpJackIds[x]);
@@ -959,31 +988,23 @@
 					{
 						char successMsg[220];
 						sprintf(successMsg,"Bear Rug Co: There are %d inactive pumpjacks to the North that survied that meteor impact, hurry up and activate them.",inactivePumpjackCount);
-						JmgUtility::Create_2D_Wave_Sound_Dialog("BH18.mp3");
-						JmgUtility::MessageAllPlayers(127,127,255,successMsg);
+						BearHunterVoiceSystem::PlayVoice("BH18.mp3",successMsg);
 						unsigned int textId = (7-inactivePumpjackCount == 1) ? 12752 : (7-inactivePumpjackCount == 2) ? 12753 : (7-inactivePumpjackCount == 3) ? 12754 : (7-inactivePumpjackCount == 4) ? 12755 : 12756;
 						NewObjectiveSystemControl.Set_Objective_Mission(16,textId,textId);
 					}
 					if (!livingPumpjacks)
 					{
 						if (!inactivePumpjackCount)
-						{
-							JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: All of the pump jacks to the North were destroyed by that meteor, guess we should have repaired them!");
-							JmgUtility::Create_2D_Wave_Sound_Dialog("BH19.mp3");
-						}
+							BearHunterVoiceSystem::PlayVoice("BH19.mp3","Bear Rug Co: All of the pump jacks to the North were destroyed by that meteor, guess we should have repaired them!");
 						else
-						{
-							JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like that meteor impact also wiped out all the pumpjacks to the North!");
-							JmgUtility::Create_2D_Wave_Sound_Dialog("BH20.mp3");
-						}
+							BearHunterVoiceSystem::PlayVoice("BH20.mp3","Bear Rug Co: Looks like that meteor impact also wiped out all the pumpjacks to the North!");
 						NewObjectiveSystemControl.Set_Objective_Status(16,NewObjectiveSystem::Failed);
 					}
 				}
 			}
 			if (gameTime == 1180)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like it was, and mutation has already spread to the local bears, I bet those pelts would be worth way more than a normal bears'... You should head North, there is a little house with supplies.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH21.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH21.mp3","Bear Rug Co: Looks like it was, and mutation has already spread to the local bears, I bet those pelts would be worth way more than a normal bears'... You should head North, there is a little house with supplies.");
 				objective = 12696;
 				JmgUtility::SetHUDHelpText(objective,Vector3(0,1,0));
 				NewObjectiveSystemControl.Set_Objective_Status(2,NewObjectiveSystem::Accomplished);
@@ -1001,8 +1022,7 @@
 				node = bearHunterWolfHivemindControl.find(3);
 				if (node)
 					node->maxPackSize = 0;
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Local deer have begun to show effects of mutation, we're locking the base down for the President of Corporate America's safety!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH22.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH22.mp3","Bear Rug Co: Local deer have begun to show effects of mutation, we're locking the base down for the President of Corporate America's safety!");
 				Commands->Static_Anim_Phys_Goto_Last_Frame(650184,"BH_GATE_1.BH_GATE_1");
 				Commands->Static_Anim_Phys_Goto_Last_Frame(650183,"BH_GATE_1.BH_GATE_1");
 				Commands->Static_Anim_Phys_Goto_Last_Frame(650190,"BH_GATE_1.BH_GATE_1");
@@ -1010,8 +1030,7 @@
 			}
 			if (gameTime == 875)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Shit! Looks like there has been a failure in the gate control mainframe, fall back and defend the President of Corporate America!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH23.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH23.mp3","Bear Rug Co: Shit! Looks like there has been a failure in the gate control mainframe, fall back and defend the President of Corporate America!");
 				sprintf(currentSong,"SpecForce_Moments02.mp3");
 				Commands->Fade_Background_Music("SpecForce_Moments02.mp3",10000,10000);
 				objective = 12697;
@@ -1028,25 +1047,22 @@
 			}
 			if (gameTime == 835 && !JMG_Bear_Hunter_Game_Control::hasGotTurrets && NewObjectiveSystemControl.Get_Objective_Status(10) == NewObjectiveSystem::Pending)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Our engineers report if the truck isn't back in the next minute they won't be able to get them set up!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH24.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH24.mp3","Bear Rug Co: Our engineers report if the truck isn't back in the next minute they won't be able to get them set up!");
 			}
 			if (gameTime == 775)
 			{
 				gameState = FallBack;
 				spawnGroup = 2;
-				Vector3 truckPos;
+				GameObject *truck = Commands->Find_Object(JMG_Bear_Hunter_Security_Turret_Truck::id);
 				if (!JMG_Bear_Hunter_Game_Control::hasGotTurrets)
-					if (NewObjectiveSystemControl.Get_Objective_Status(10) == NewObjectiveSystem::Pending && NewObjectiveSystemControl.Get_Radar_Blip_Position(10,&truckPos) && JmgUtility::SimpleFlatDistance(JMG_Bear_Hunter_Game_Control::centerOfBase,truckPos) <= 160000)
+					if (NewObjectiveSystemControl.Get_Objective_Status(10) == NewObjectiveSystem::Pending && truck && JmgUtility::SimpleFlatDistance(JMG_Bear_Hunter_Game_Control::centerOfBase,Commands->Get_Position(truck)) <= 160000)
 					{
 						truckTimeExtended = true;
-						JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We see the truck is getting close, the engineers are going to give you another 45 seconds! Everyone else fall back to base!");
-						JmgUtility::Create_2D_Wave_Sound_Dialog("BH25.mp3");
+						BearHunterVoiceSystem::PlayVoice("BH25.mp3","Bear Rug Co: We see the truck is getting close, the engineers are going to give you another 45 seconds! Everyone else fall back to base!");
 					}
 					else
 					{
-						JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Forget about the turret parts there isn't enough time! Fall back to base!");
-						JmgUtility::Create_2D_Wave_Sound_Dialog("BH26.mp3");
+						BearHunterVoiceSystem::PlayVoice("BH26.mp3","Bear Rug Co: Forget about the turret parts there isn't enough time! Fall back to base!");
 						if (NewObjectiveSystemControl.Get_Objective_Status(10) != NewObjectiveSystem::Accomplished)
 						{
 							NewObjectiveSystemControl.Remove_Objective(9);
@@ -1054,10 +1070,7 @@
 						}
 					}
 				else
-				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Everyone fall back to base!");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH27.mp3");
-				}
+					BearHunterVoiceSystem::PlayVoice("BH27.mp3","Bear Rug Co: Everyone fall back to base!");
 				Commands->Enable_Spawner(600536,false);
 				if (NewObjectiveSystemControl.Get_Objective_Status(14) == NewObjectiveSystem::Pending)
 					NewObjectiveSystemControl.Remove_Objective(14);
@@ -1066,19 +1079,15 @@
 			}
 			if (gameTime == 730 && !JMG_Bear_Hunter_Game_Control::hasGotTurrets && truckTimeExtended)
 			{
-				Vector3 truckPos;
-				if (NewObjectiveSystemControl.Get_Objective_Status(10) == NewObjectiveSystem::Pending && NewObjectiveSystemControl.Get_Radar_Blip_Position(10,&truckPos) && JmgUtility::SimpleFlatDistance(JMG_Bear_Hunter_Game_Control::centerOfBase,truckPos) <= 10000)
-				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We're giving you another 15 seconds to get those turret parts inside DERP Industries beings your so close!");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH28.mp3");
-				}
+				GameObject *truck = Commands->Find_Object(JMG_Bear_Hunter_Security_Turret_Truck::id);
+				if (NewObjectiveSystemControl.Get_Objective_Status(10) == NewObjectiveSystem::Pending && truck && JmgUtility::SimpleFlatDistance(JMG_Bear_Hunter_Game_Control::centerOfBase,Commands->Get_Position(truck)) <= 10000)
+					BearHunterVoiceSystem::PlayVoice("BH28.mp3","Bear Rug Co: We're giving you another 15 seconds to get those turret parts inside DERP Industries beings your so close!");
 				else
 				{
 					truckTimeExtended = false;
 					if (NewObjectiveSystemControl.Get_Objective_Status(10) != NewObjectiveSystem::Accomplished)
 					{
-						JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We need all the engineers back to work on the gates, there is no more time for the turret parts!");
-						JmgUtility::Create_2D_Wave_Sound_Dialog("BH29.mp3");
+						BearHunterVoiceSystem::PlayVoice("BH29.mp3","Bear Rug Co: We need all the engineers back to work on the gates, there is no more time for the turret parts!");
 						NewObjectiveSystemControl.Remove_Objective(9);
 						NewObjectiveSystemControl.Remove_Objective(10);
 					}
@@ -1089,27 +1098,21 @@
 				truckTimeExtended = false;
 				if (NewObjectiveSystemControl.Get_Objective_Status(10) != NewObjectiveSystem::Accomplished)
 				{
-					JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Forget the turret parts and fall back to base, there isn't any more time to set them up!");
-					JmgUtility::Create_2D_Wave_Sound_Dialog("BH30.mp3");
+					BearHunterVoiceSystem::PlayVoice("BH30.mp3","Bear Rug Co: Forget the turret parts and fall back to base, there isn't any more time to set them up!");
 					NewObjectiveSystemControl.Remove_Objective(9);
 					NewObjectiveSystemControl.Remove_Objective(10);
 				}
 			}
 			if (gameTime == 700)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: This could get pretty intense, if you have a chance try to head West, you will find a radio tower, if you can activate it we can call for backup.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH31.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH31.mp3","Bear Rug Co: This could get pretty intense, if you have a chance try to head West, you will find a radio tower, if you can activate it we can call for backup.");
 				NewObjectiveSystemControl.Add_Objective(21,NewObjectiveSystem::Secondary,NewObjectiveSystem::Pending,12789,"",12789,Vector3(-512.0f,-270.705f,76.11f));
 			}
 			if (gameTime == 624)
-			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Watch your backs, there are mutant dogs out there now!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH32.mp3");
-			}
+				BearHunterVoiceSystem::PlayVoice("BH32.mp3","Bear Rug Co: Watch your backs, there are mutant dogs out there now!");
 			if (gameTime == 400 && objective != 12698)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Mutant squirrels incoming, this is just getting to be too much, fall back and defend the President of Corporate America!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH33.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH33.mp3","Bear Rug Co: Mutant squirrels incoming, this is just getting to be too much, fall back and defend the President of Corporate America!");
 				NewObjectiveSystemControl.Remove_Objective(5);
 				JmgUtility::SetHUDHelpText(objective,Vector3(0,1,0));
 				objective = 12698;
@@ -1121,8 +1124,7 @@
 			}
 			if (gameTime == 320)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like cats are infected now too, I think I'll just be leaving...");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH34.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH34.mp3","Bear Rug Co: Looks like cats are infected now too, I think I'll just be leaving...");
 				sprintf(currentSong,"304824_Goliath__Club_Remix_.mp3");
 				Commands->Fade_Background_Music("304824_Goliath__Club_Remix_.mp3",10000,10000);
 			}
